package mole.state 
{
	import flash.geom.Point;
	
	/**
	 * Interface d'état du jeu.
	 * @author Cédric Liaudet
	 */
	public interface IState 
	{
		/**
		 * Chargement des données.
		 */
		function OnStart():void;
		
		/**
		 * Mise à jours de l'état.
		 */
		function OnUpdate(): void;
		
		/**
		 * "Destruction" des données.
		 */
		function OnEnd():void;
		
		/**
		 * Mise en pause
		 */
		function OnPause():void;
		
		/**
		 * Retour de pause
		 */
		function OnResume():void;
	}	
}